#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN=1e5+5;
const ll INF=9e18;

struct Line
{
    ll k,n;

    Line() {};
    Line(ll _k,ll _n)
    {
        k=_k;
        n=_n;
    }

    ll eval(ll x)
    {
        return k*x+n;
    }
};

struct Obj
{
    int d;
    int buy,sell;
    int k;
};

int n;
int c,d;
Obj a[MAXN];
ll dp[MAXN];

ll intersect(Line a,Line b)
{
    ll dk=a.k-b.k;
    ll dn=b.n-a.n;
    if(dk==0) return (a.n>b.n ? -INF : INF);
    return (dn+dk-1)/dk;
}

void add(vector<Line> &v, Line t)
{
    while(v.size()>=2 && intersect(t,v[v.size()-2])>=intersect(t,v[v.size()-1])) v.pop_back();
    v.push_back(t);
}

bool cmpLine(Line a,Line b)
{
    if(a.k==b.k) return a.n<b.n;
    return a.k<b.k;
}

vector<Line> cdq(int l,int r)
{
    if(l==r)
    {
        if(dp[l]>=0) return {Line(a[l].k, dp[l]+a[l].sell-1LL*(a[l].d+1)*a[l].k)};
        else return {};
    }

    int mid=(l+r)/2;

    vector<Line> vl=cdq(l,mid);

    if(vl.size()>0)
    {
        int ptrL=0;
        for(int i=mid+1; i<=r; i++)
        {
            while(ptrL+1<vl.size() && vl[ptrL].eval(a[i].d)<vl[ptrL+1].eval(a[i].d)) ptrL++;
            dp[i]=max(dp[i], vl[ptrL].eval(a[i].d)-a[i].buy);
        }
    }

    vector<Line> vr=cdq(mid+1,r);

    vector<Line> v;
    int ptrL=0;
    int ptrR=0;
    while(ptrL<vl.size() && ptrR<vr.size())
    {
        if(cmpLine(vl[ptrL],vr[ptrR])) add(v, vl[ptrL++]);
        else add(v, vr[ptrR++]);
    }
    while(ptrL<vl.size()) add(v, vl[ptrL++]);
    while(ptrR<vr.size()) add(v, vr[ptrR++]);
    vector<Line> ().swap(vl);
    vector<Line> ().swap(vr);

    return v;
}

bool cmp(Obj a,Obj b)
{
    return a.d<b.d;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n>>c>>d;
    a[0]= {0,0,c,0};
    for(int i=1; i<=n; i++)
    {
        cin>>a[i].d>>a[i].buy>>a[i].sell>>a[i].k;
    }
    a[n+1]= {d+1,0,0,0};

    sort(a,a+n+2,cmp);

    dp[0]=0;
    for(int i=1; i<=n+1; i++) dp[i]=-INF;

    cdq(0,n+1);

    cout<<dp[n+1]<<endl;

    return 0;
}
